<?php
namespace Ems\portalGestor\Service;

use Ems\portalGestor\Util\HcmServices;
use Ems\portalGestor\Repository\ParamOrgRepository;

class ParamOrgService {

    /** @var HcmServices */
    protected $hcmServices;

    /** @var ParamOrgRepository */
    protected $paramOrgRepository;

    public function __construct(
        HcmServices $hcmServices,
        ParamOrgRepository $paramOrgRepository
    ) {
        $this->hcmServices = $hcmServices;
        $this->paramOrgRepository = $paramOrgRepository;
    }

    public function getValorReferencia(
        array $row
    ) {
        $nrOrg = (int) $row['NRORG'];

        $hcmServicesRoute = 'getValorReferencia';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $valor = $response['dataset'][$hcmServicesRoute]['valor'];

        return $valor;
    }

    public function getNrColetorGestor(
        int $nrOrg
    ) {
        $paramOrg = $this->paramOrgRepository->getParamOrg($nrOrg);

        if ($paramOrg && isset($paramOrg['NRCOLETORGESTOR'])) {
            return $paramOrg['NRCOLETORGESTOR'] ?? null;
        }

        return null;
    }

    public function getNrColetorBatida(
        int $nrOrg
    ) {
        $paramOrg = $this->paramOrgRepository->getParamOrg($nrOrg);

        if ($paramOrg && isset($paramOrg['NRCOLETORMARCBATIDA'])) {
            return $paramOrg['NRCOLETORMARCBATIDA'] ?? null;
        }

        return null;
    }

    public function get(
        int $nrOrg
    ) {
        return $this->paramOrgRepository->getParamOrg($nrOrg);
    }
}
